#ifndef EAVESDROPPER_CONNECTION_H
#define EAVESDROPPER_CONNECTION_H

// ***************************************************************************
// System Includes
// ***************************************************************************

#include <be/interface/Point.h>

// ***************************************************************************
// Project Includes
// ***************************************************************************

// Standard type and constant definitions.
#include "StyleGuideDefs.h"

// ***************************************************************************
// External Name Declarations
// ***************************************************************************

class BView;
class ConnectorView;

// ***************************************************************************
// External Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Constant Definitions
// ***************************************************************************

// ***************************************************************************
// Type Definitions
// ***************************************************************************

// ***************************************************************************
// Class Definition
// ***************************************************************************

/** 
 * The Connection class can draw a connection between two connectors.
 */
class Connection 
{
public:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	// Member Function Definitions ===========================================

	/**
	 * Constructor.
	 *
	 * @param sourceConnector The output-end of the connection.
	 * @param destinationConnector The input-end of the connection.
	 */
	Connection(ConnectorView* sourceConnector,
		ConnectorView* destinationConnector);

	/** Automatically generated copy constructor. */
	// Connection(const Connection& old);

	/** Automatically generated destructor. */
	// virtual ~Connection(void);

	/** Automatically generated assignment operator. */
	// Connection& operator=(Connection& right);

	/** Draws the connection in a certain BView. */
	void Draw(BView* destinationView);

protected:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	// Member Function Definitions ===========================================

private:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	/**
	 * The coordinates of the source connector. We store these to be able to
	 * erase the old line.
	 */
	BPoint sourcePoint;
	
	/**
	 * The coordinates of the destination connector. We store these to be
	 * able to erase the old line.
	 */
	BPoint destinationPoint;

	/** The output-end of the connection. */
	ConnectorView* sourceConnector;
	
	/** The input-end of the connection. */
	ConnectorView* destinationConnector;

	// Member Function Definitions ===========================================
};

// ***************************************************************************
// Global Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Inline Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Declarations
// ***************************************************************************

// ***************************************************************************
// Global Function Declarations
// ***************************************************************************

#endif // EAVESDROPPER_CONNECTION_H
