#ifndef EAVESDROPPER_LIVENODESVIEW_H
#define EAVESDROPPER_LIVENODESVIEW_H

// ***************************************************************************
// System Includes
// ***************************************************************************

#include <be/interface/View.h>
#include <be/support/List.h>

// ***************************************************************************
// Project Includes
// ***************************************************************************

#include "StyleGuideDefs.h"         // Standard type and constant definitions.

// ***************************************************************************
// External Name Declarations
// ***************************************************************************

class LiveNodeView;
class ConnectorView;
class InfoWindow;

// ***************************************************************************
// External Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Constant Definitions
// ***************************************************************************

// ***************************************************************************
// Type Definitions
// ***************************************************************************

// ***************************************************************************
// Class Definition
// ***************************************************************************

/**
 * The LiveNodesView class is the container view for the LiveNodeViews.
 */
class LiveNodesView : public BView
{
public:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	// Member Function Definitions ===========================================

	/**
	 * Constructor.
	 *
	 * @param frame The frame rectangle of the view.
	 */
	LiveNodesView(BRect frame);

	/** Automatically generated copy constructor. */
	// LiveNodesView(const LiveNodesView& old);

	/** Automatically generated destructor. */
	// virtual ~LiveNodesView(void);

	/** Automatically generated assignment operator. */
	// LiveNodesView& operator=(LiveNodesView& right);

	/** Handles the messages that this view receives. */
	virtual void MessageReceived(BMessage* message);
	
	/** Draws the view. */
	void Draw(BRect updateRect);

	/** Redraws the connections after the view has been scrolled. */
	virtual void ScrollTo(BPoint point);

	/** Tells all connections to draw themselves into our view. */
	virtual void RedrawConnections(void);
  
	/** Tells us which connections we should draw. */
	void SetConnections(BList* connections);

protected:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	// Member Function Definitions ===========================================

private:
	// Constant Definitions ==================================================

	// Type Definitions ======================================================

	// Attribute Definitions =================================================

	/** The Connections that we should draw. */
	BList* connections;

	// Member Function Definitions ===========================================
};

// ***************************************************************************
// Global Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Inline Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Declarations
// ***************************************************************************

// ***************************************************************************
// Global Function Declarations
// ***************************************************************************

#endif // EAVESDROPPER_LIVENODESVIEW_H
